/*-----------------------------------------------------------.
/                          Vignette                           /
'-----------------------------------------------------------*/
/*
Version 1.3

Darkens the edges of the image to make it look more like it was shot with a camera lens.
May cause banding artifacts.
*/

//Make sure the VignetteRatio exits to avoid breaking if the user uses a Settings for a previous version that didn't include this

/*
//Logical XOR - not used right now but it might be useful at a later time
float XOR( float xor_A, float xor_B )
{
return saturate( dot(float4(-xor_A ,-xor_A ,xor_A , xor_B) , float4(xor_B, xor_B ,1.0 ,1.0 ) ) ); // -2 * A * B + A + B
}
*/

float4 VignettePass( float4 colorInput, float2 tex )
{
    //Set the center
    float2 distance_xy = tex - VignetteCenter;

    //Adjust the ratio
    {
          distance_xy *= float2((pixel.y / pixel.x),VignetteRatio);
     }

    //Calculate the distance
    distance_xy /= VignetteRadius;
    float distance = dot(distance_xy,distance_xy);

    //Apply the vignette
    colorInput.rgb *= (1.0 + pow(distance, VignetteSlope * 0.5) * VignetteAmount); //pow - multiply

return colorInput;
}
